var _=require("lodash");
jvfs=((perms=false)=>{
    var a=(function(t){app.ShowPopup(JSON.stringify(t));});
    var filesystem={fs:{}};
    var out={};
    out.isperms=(perms===true);
    if(out.isperms){
        filesystem.perms={};
        filesystem.perms.users={};
        out.perms={};
        out.perms.adduser=((opts)=>{
            var user={};
            var name=opts.user;
            user.read={
                allow:[],
                deny:[],
                aod:false
            };
            user.write={
                allow:[],
                deny:[],
                aod:false
            };
            filesystem.perms.users[name]=user;
        });
        out.perms.deluser=((user)=>{
            delete filesystem.perms.users[user];
        });
        out.perms.read={
            add:{
                allow:(u,d)=>{
                    d=out.resolve(d);
                    var allow=filesystem.perms.users[u].read.allow;
                    if(allow.indexOf(d)<0){
                        allow.push(d);
                        filesystem.perms.users[u].read.allow=allow;
                        return true;
                    }
                    return false;
                },
                deny:(u,d)=>{
                    d=out.resolve(d);
                    var deny=filesystem.perms.users[u].read.deny;
                    if(deny.indexOf(d)<0){
                        deny.push(d);
                        filesystem.perms.users[u].read.deny=deny;
                        return true;
                    }
                    return false;
                }
            },
            del:{
                allow:(u,d)=>{
                    d=out.resolve(d);
                    var allow=filesystem.perms.users[u].read.allow;
                    if(allow.indexOf(d)>=0){
                        allow.splice(allow.indexOf(d),1);
                        filesystem.perms.users[u].read.allow=allow;
                        return true;
                    }
                    return false;
                },
                deny:(u,d)=>{
                    d=out.resolve(d);
                    var deny=filesystem.perms.users[u].read.deny;
                    if(deny.indexOf(d)>=0){
                        deny.splice(deny.indexOf(d),1);
                        filesystem.perms.users[u].read.deny=deny;
                        return true;
                    }
                    return false;
                }
            },
            aod:(u,o=null)=>{
                if(o===null){
                    return filesystem.perms.users[u].read.aod;
                }
                filesystem.perms.users[u].read.aod=o;
            }
        };
        out.perms.write={
            add:{
                allow:(u,d)=>{
                    d=out.resolve(d);
                    var allow=filesystem.perms.users[u].write.allow;
                    if(allow.indexOf(d)<0){
                        allow.push(d);
                        filesystem.perms.users[u].write.allow=allow;
                        return true;
                    }
                    return false;
                },
                deny:(u,d)=>{
                    d=out.resolve(d);
                    var deny=filesystem.perms.users[u].write.deny;
                    if(deny.indexOf(d)<0){
                        deny.push(d);
                        filesystem.perms.users[u].write.deny=deny;
                        return true;
                    }
                    return false;
                }
            },
            del:{
                allow:(u,d)=>{
                    d=out.resolve(d);
                    var allow=filesystem.perms.users[u].write.allow;
                    if(allow.indexOf(d)>=0){
                        allow.splice(allow.indexOf(d),1);
                        filesystem.perms.users[u].write.allow=allow;
                        return true;
                    }
                    return false;
                },
                deny:(u,d)=>{
                    d=out.resolve(d);
                    var deny=filesystem.perms.users[u].write.deny;
                    if(deny.indexOf(d)>=0){
                        deny.splice(deny.indexOf(d),1);
                        filesystem.perms.users[u].write.deny=deny;
                        return true;
                    }
                    return false;
                }
            },
            aod:(u,o=null)=>{
                if(o===null){
                    return filesystem.perms.users[u].write.aod;
                }
                filesystem.perms.users[u].write.aod=o;
            }
        };
    }
    var swap=((path)=>{
        var t=path.substr(0,1);
        if(t=="."){//[lodash mode true]
            while(path.replace("..",".")!=path){path=path.replace("..",".");}
        }
        if(t=="/"){//[file mode true]
            while(path.replace("//","/")!=path){path=path.replace("//","/");}
        }
        var aa="[+dot-]";
        var bb="[+slash-]";
        while(path.replace(".",aa)!=path){path=path.replace(".",aa);}
        while(path.replace("/",bb)!=path){path=path.replace("/",bb);}
        while(path.replace(bb,".")!=path){path=path.replace(bb,".");}
        while(path.replace(aa,"/")!=path){path=path.replace(aa,"/");}
        if(t=="/"){//[lodash mode true]
            if(path=="."){
                path="";
            }
        }
        if(t=="."&&path.substr(path.length-1,path.length)=="/"){
            path=path.substr(0,path.length-1);
        }
        return path;
    });
    out.doperm=((u,path,type)=>{
        path=out.parent(path);
        if(out.isperms){
            if(u===null){return false;}
            if(filesystem.perms.users[u][type].aod){
                var allowed=filesystem.perms.users[u][type].allow;
                var go=0;
                for(var i=0;i<allowed.length;i++){
                    var allow=":"+allowed[i];
                    if((":"+path).replace(allow,"")!=allow){
                        return true;
                    }
                }
                return false;
            }else{
                var denied=filesystem.perms.users[u][type].deny;
                var stop=0;
                for(var i=0;i<denied.length;i++){
                    var deny=":"+denied[i];
                    if((":"+path).replace(deny,"")!=deny){
                        return false;
                    }
                }
                return true;
            }
        }
        return true;
    });
    out.type=((path,u)=>{
        u=(typeof(u)!="undefined")?u:null;
        path=out.resolve("/"+path);
        var _path="fs"+swap(path);
        var t=typeof(_.get(filesystem,_path));
        if(!out.doperm(u,path,"read")){return false;}
        if(t=="object"){
            return "folder";
        }
        if(t=="string"){
            return "file";
        }
        return false;
    });
    out.resolve=((path)=>{
        return swap(swap("/"+path));
    });
    out.exists=((path,u)=>{
        u=(typeof(u)!="undefined")?u:null;
        path=out.resolve("/"+path);
        var _path="fs"+swap(path);
        if(!out.doperm(u,path,"read")){return false;}
        return (out.type(path,u)!=false);
    });
    out.parent=((path)=>{
        path=out.resolve("/"+path);
        path=path.split("/");
        path.pop();
        path=path.join("/");
        if(path==""){path="/";}
        return path;
    });
    out.rmdir=((path,u)=>{
        u=(typeof(u)!="undefined")?u:null;
        path=out.resolve("/"+path);
        var _path="fs"+swap(path);
        if(out.type(path,u)=="folder"){
            if(!out.doperm(u,path,"write")){return false;}
            _.unset(filesystem,_path);
            return true;
        }
        return false;
    });
    out.deletefile=((path,u)=>{
        u=(typeof(u)!="undefined")?u:null;
        path=out.resolve("/"+path);
        var _path="fs"+swap(path);
        if(out.type(path,u)=="file"){
            if(!out.doperm(u,path,"write")){return false;}
            _.unset(filesystem,_path);
            return true;
        }
        return false;
    });
    out.mkdir=((path,u)=>{
        u=(typeof(u)!="undefined")?u:null;
        path=out.resolve("/"+path);
        var _path="fs"+swap(path);
        if(out.type(path,u)==false){
            if(out.type(out.parent(path),u)=="folder"){
                if(!out.doperm(u,path,"write")){return false;}
                _.setWith(filesystem,_path,{});
                return true;
            }
            return false;
        }
        return false;
    });
    out.readfile=((path,u)=>{
        u=(typeof(u)!="undefined")?u:null;
        path=out.resolve("/"+path);
        var _path="fs"+swap(path);
        if(out.type(path,u)=="file"){
            if(out.type(out.parent(path),u)=="folder"){
                if(!out.doperm(u,path,"read")){return false;}
                return _.get(filesystem,_path);
            }
            return false;
        }
        return false;
    });
    out.writefile=((path,inp,u)=>{
        u=(typeof(u)!="undefined")?u:null;
        path=out.resolve("/"+path);
        var _path="fs"+swap(path);
        if(out.type(path,u)!="folder"){
            if(out.type(out.parent(path),u)=="folder"){
                if(!out.doperms(u,path,"write")){return false;}
                _.setWith(filesystem,_path,inp);
                return true;
            }
            return false;
        }
        return false;
    });
    out.readdir=((path,u)=>{
        u=(typeof(u)!="undefined")?u:null;
        path=out.resolve("/"+path);
        var _path="fs"+swap(path);
        if(out.type(path,u)=="folder"){
            if(!out.doperm(u,path,"read")){return false;}
            var f=[];
            var files=Object.keys(_.get(filesystem,_path));
            files.forEach((v,i)=>{
                v=swap(v);
                f.push(v);
            });
            return f;
        }
        return false;
    });
    out.rawfs=((fs=null)=>{
        if(fs!==null){
            filesystem.fs=fs;
        }else{
            return filesystem.fs;
        }
    });
    out.importfs=((vfsData)=>{
        if(!out.isperms){
            filesystem.fs=JSON.parse(new Buffer(vfsData,"base64").toString("ascii"),true);
        }else{
            filesystem=JSON.parse(new Buffer(vfsData,"base64").toString("ascii"),true);
        }
    });
    out.exportfs=(()=>{
        if(!out.isperms){
            return new Buffer(JSON.stringify(filesystem.fs)).toString("base64");
        }else{
            return new Buffer(JSON.stringify(filesystem)).toString("base64");
        }
    });
    out.importfile=((path)=>{
        var jvfs1=require("fs").readFileSync(path);
        out.importfs(vfs1);
    });
    out.exportfile=((path)=>{
        var jvfs1=out.exportfs();
        require("fs").writeFileSync(path,jvfs1);
    });
    return out;
});
module.exports=jvfs;